﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridHideNewColumns
{
    public partial class Form1 : Form
    {
        DataSet ds = new DataSet();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {


            ultraGrid1.DisplayLayout.NewColumnLoadStyle = Infragistics.Win.UltraWinGrid.NewColumnLoadStyle.Hide;

            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int));
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int)).AllowDBNull = false;
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Address", typeof(string));
            t2.Columns.Add("Number", typeof(int));

            ds.Tables["table1"].Rows.Add(new Object[] { 0, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { 1, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { 2, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { 3, "Furniture", 12, 79, new DateTime(2009, 02, 28) });

            ds.Tables["table2"].Rows.Add(new Object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 1, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 2, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new Object[] { null, 3, "Coca - Cola", " Somewhere", 2 });

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);
            ultraGrid1.SetDataBinding(ds, "table1");

            ultraGrid1.DisplayLayout.AddNewBox.Hidden = false;  
            
        }

        private void ultraGrid1_BeforeRowUpdate(object sender, Infragistics.Win.UltraWinGrid.CancelableRowEventArgs e)
        {
            if (e.Row.Band.Index == 1 )
            {
                int pidValue = (int)e.Row.Cells["pid"].Value;
                foreach (var row in ultraGrid1.Rows)
                {
                    if ((int)row.Cells[0].Value == pidValue)
                        return;
                }
                ds.Tables["table1"].Rows.Add(new Object[] 
                { pidValue, null, null, null, null }); 
            }
        }
    }
}
